# -*- coding: utf-8 -*-
"""
Created on Tue Jun  8 16:33:53 2021

@author: Fred
"""
from random import randint
from classe_machine import *
import tkinter as tk

class GUISaisieTuring(tk.Toplevel):
    def __init__(self, fenetre_fille, taille_police, 
                 etats_standards, lg_ruban, nb_etats, machine, modif, fen_mere):

        self.machine = machine
        # variables métier
        #  des doublons et assez crasseux entre machine, self.machine et fen_mere.machine
        #  mais trop la flemme de nettoyer
        #  de même la logique de programmation n'est pas cohérente entre les différentes méthodes.
        (self.ETAT_INIT, self.CODE_INIT, 
         self.ETAT_FIN, self.CODE_FIN,
         self.ETAT_VRAI, self.CODE_VRAI, 
         self.ETAT_FAUX, self.CODE_FAUX) = etats_standards
        self.etats = {self.CODE_INIT: self.ETAT_INIT , self.CODE_FIN: self.ETAT_FIN} 
        self.nb_etats = nb_etats
        self.liste_etats = [self.ETAT_INIT] +\
            ["Etat " + str(i) for i in range(1,9)] +\
                [self.ETAT_FIN, self.ETAT_VRAI, self.ETAT_FAUX]
        self.etats_construits = [True] + [False]*(nb_etats - 2) + [True, False, False]
        if modif :
            for i in range(self.nb_etats + 2):
                self.etats_construits[i] = False
            for cle in machine.etats.keys():
                self.liste_etats[cle] = machine.etats[cle]
                self.etats_construits[cle] = True
        #  Contruction d'un ruban aléatoire
        #  Symboles 0, 1, 2 pour vide
        #  La 1ère case est vide
        self.lg_ruban = lg_ruban
        if modif :
            self.ruban = machine.deroulement[0][0]
        else: 
            self.ruban = [randint(0,4)//2 for i in range(self.lg_ruban)]
            self.ruban[0] = 2
        self.transitions = {}        #  transitions, dictionnaire 
                                     #  clés : couples (symbole lu, état courant)
                                     #  valeurs : triplet (symbole écrit, etat suivant
                                     #                     déplacement)
                                     #            déplacement +1 droite, -1 gauche, 0 rien
        if modif :
            self.resume = machine.resume
        else :
            self.resume = ""
        
        # variables graphiques
        self.modif = modif
        self.texte_symboles = {0: "0", 1 : "1", 2 : "\u25a2"}
        self.fen = fenetre_fille
        self.fen.grab_set()        # empeche d'utiliser la fenêtre principale
        self.fen_mere = fen_mere
        if taille_police >=10 :
            self.taille_police = taille_police - 2
        else:
            self.taille_police = taille_police 
        self.fen.title("Saisie d'une machine de Turing")
        self.fen.configure(background='white')
        self.etape_saisie = 0     # 0 pour saisie des états, 1 pour saisie des transitions
        
        # Etats
        self.label_init = tk.Label(self.fen, text = "Etat initial non modifiable", 
                                    font=("Arial", self.taille_police),
                                      borderwidth=1, relief="raised", padx = 2, pady = 2,
                                      bg = "ivory2")
        self.label_finaux = tk.Label(self.fen, text = "Etat final : FIN", 
                                    font=("Arial", self.taille_police),
                                      borderwidth=1, relief="raised", padx = 2, pady = 2,
                                      bg = "ivory2")
        self.label_intermediaires = tk.Label(self.fen, text = "Saisir le nom des états et cliquer à côté :", 
                                    font=("Arial", self.taille_police),
                                      borderwidth=1, relief="raised", padx = 2, pady = 2,
                                      bg = "ivory2")
        self.acne = []       # liste des boutons des états
        self.acne.append(tk.Button(self.fen, text="INIT", state = "disabled",
                              relief = "raised", font=("Arial", self.taille_police),
                              bd = 3, command = None, padx = 3, pady = 3))
        for i in range(1,9):
            self.acne.append(tk.Button(self.fen, text="Etat " + str(i), bd = 1, 
                                       padx = 3, pady = 3, state = "disabled",
                                  relief = "sunken", font=("Arial", self.taille_police),
                                  command = lambda  idx = i : self.saisie_etat
                                  (idx, self.etape_saisie, machine)))  
        self.acne[1].configure(state = "normal")
        self.acne.append(tk.Button(self.fen, text="FIN", state = "disabled",
                                   padx = 3, pady = 3,
                              relief = "raised", font=("Arial", self.taille_police),
                              bd = 3, command = lambda : self.choix_fin_fin(machine)))
        self.acne.append(tk.Button(self.fen, text="VRAI",
                                   padx = 3, pady = 3,
                              relief = "sunken", font=("Arial", self.taille_police),
                              bd = 1, command = lambda : self.choix_fin_vrai(machine)))
        self.acne.append(tk.Button(self.fen, text="FAUX", state = "disabled",
                                   padx = 3, pady = 3,
                              relief = "sunken", font=("Arial", self.taille_police),
                              bd = 1, command = None))


        self.noms_etats = [tk.StringVar(self.fen) for i in range(9)]
        self.noms_etats_entree = []
        for i in range(9):
            self.noms_etats_entree.append(tk.Entry(self.fen, bd =5, width = 10,
                                                   font=("Arial", self.taille_police),
                                                  textvariable = self.noms_etats[i]))
            self.noms_etats[i].set("Max 10 car")
            
        # Ruban
        self.num_ligne_ruban = 14
        self.bouton_ruban_alea = tk.Button(self.fen, text="Ruban aléatoire", bg= 'firebrick1',
                                           font=("Arial", self.taille_police),
                                  command = lambda : self.rubanAlea(machine))
        self.bouton_ruban_entree = tk.Button(self.fen, text="Rentrez un ruban",  bg= 'firebrick1',
                                           font=("Arial", self.taille_police),
                                  command = lambda : self.rubanEntree(machine))
        texte_explication = "Pour rentrer un ruban : 2 pour vide, commence et finit par 2, max " +\
                            str(self.lg_ruban) + " symboles 0/1/2"
        self.label_ruban_explications = tk.Label(self.fen, 
                            text = texte_explication, 
                              font=("Arial", self.taille_police), bg= 'firebrick1',)
        self.ruban2ChaineRuban()
        self.label_ruban = tk.Label(self.fen, text =  self.chaine_ruban, 
                              font=("Arial", self.taille_police),
                              borderwidth=1, relief="solid", padx = 0, pady = 0, 
                              bg = 'firebrick1', fg = 'black')
        self.entree_ruban_text = tk.StringVar(self.fen)
        self.entree_ruban_text.set(self.chaine_ruban)
        self.entree_ruban = tk.Entry(self.fen, bd =5, width = 30, 
                                      font=("Arial", self.taille_police),
                                      textvariable = self.entree_ruban_text, bg= 'firebrick1')
        
        
        #  Résumé
        self.bouton_resume = tk.Button(self.fen, text = "Que fait la machine : saisir à coté puis cliquer ici", 
                                    font=("Arial", self.taille_police),
                                      borderwidth=1, relief="raised", padx = 2, pady = 2,
                                      bg = "ivory1", command = lambda : self.modifResume(machine))
        self.entree_resume_text = tk.StringVar(self.fen)
        self.entree_resume_text.set("Rentrer maximum 70 caractères.")
        self.entree_resume = tk.Entry(self.fen, bd =5, width = 70, bg = "ivory1",
                                      font=("Arial", self.taille_police),
                                      textvariable = self.entree_resume_text)
        if modif:
            self.bouton_resume.configure(text = self.resume)
            self.entree_resume_text.set(self.resume)
        
        #  Transitions (états)
        self.def_transition = {}
        self.def_lu = 0
        self.def_c = 0
        self.def_ecrit = 0
        self.def_s = 0
        self.def_dep = 1
        self.labels_transitions = []
        
        self.bouton_saisie_transition = tk.Button(self.fen, 
                                    text = "Définir une transition : choisir dessous et cliquer ici", 
                                    font=("Arial", self.taille_police),
                                      borderwidth=1, relief="raised", padx = 2, pady = 2,
                                      bg = "paleturquoise3", 
                                      command = lambda : self.saisieTransition(machine))
        self. label_etat_c = tk.Label(self.fen, text = "Etat courant", bg= "paleturquoise2",
                              font=("Arial", self.taille_police))
        self.choix_etat_c = tk.IntVar()
        self.choix_etat_c.set(0)
        self.radio_transitions_etats_c = []
        for i in range(self.nb_etats + 2):
            self.radio_transitions_etats_c.append(tk.Radiobutton(self.fen, 
                    text= "Etat " + str(i), variable = self.choix_etat_c,
                    state = "disabled", bg= "paleturquoise2",
                       value=i, command=lambda idx = i : self.choixEtatC(idx, machine)))
        self.radio_transitions_etats_c[0].configure(state = "normal", text = self.ETAT_INIT)
        self.radio_transitions_etats_c[-3].configure(state = "normal", text = self.ETAT_FIN)
        self.radio_transitions_etats_c[-2].configure(state = "disabled", text = self.ETAT_VRAI)
        self.radio_transitions_etats_c[-1].configure(state = "disabled", text = self.ETAT_FAUX)
        
        self.label_etat_s = tk.Label(self.fen, text = "Etat Suivant", bg= "paleturquoise2",
                              font=("Arial", self.taille_police))
        self.choix_etat_s = tk.IntVar()
        self.choix_etat_s.set(0)
        self.radio_transitions_etats_s = []
        for i in range(self.nb_etats + 2):
            self.radio_transitions_etats_s.append(tk.Radiobutton(self.fen, 
                    text= "Etat " + str(i), variable = self.choix_etat_s,
                    state = "disabled", bg= "paleturquoise2",
                       value=i, command=lambda idx = i : self.choixEtatS(idx, machine)))
        self.radio_transitions_etats_s[0].configure(state = "normal", text = self.ETAT_INIT)
        self.radio_transitions_etats_s[-3].configure(state = "normal", text = self.ETAT_FIN)
        self.radio_transitions_etats_s[-2].configure(state = "disabled", text = self.ETAT_VRAI)
        self.radio_transitions_etats_s[-1].configure(state = "disabled", text = self.ETAT_FAUX)
        
        #  Transitions (symboles et déplacement)
        self.label_lu = tk.Label(self.fen, text = "Lu", 
                              font=("Arial", self.taille_police), bg= "paleturquoise1")
        self.lu = tk.IntVar()
        self.lu.set(0)
        self.radio_lu0 = tk.Radiobutton(self.fen, text= "0", variable = self.lu,
                    value=0, command = lambda : self.choixLu(0, machine), bg= "paleturquoise1")
        self.radio_lu1 = tk.Radiobutton(self.fen, text= "1", variable = self.lu,
                    value=1, command = lambda : self.choixLu(1, machine), bg= "paleturquoise1")
        self.radio_lu2 = tk.Radiobutton(self.fen, text= "\u25a2", variable = self.lu,
                    value=2, command = lambda : self.choixLu(2, machine), bg= "paleturquoise1")
        self.label_ecrit = tk.Label(self.fen, text = "Ecrit", bg= "paleturquoise1",
                              font=("Arial", self.taille_police))
        self.ecrit = tk.IntVar()
        self.ecrit.set(0)
        self.radio_ecrit0 = tk.Radiobutton(self.fen, text= "0", variable = self.ecrit,
                    value=0, command = lambda : self.choixEcrit(0, machine), bg= "paleturquoise1")
        self.radio_ecrit1 = tk.Radiobutton(self.fen, text= "1", variable = self.ecrit,
                    value=1, command = lambda : self.choixEcrit(1, machine), bg= "paleturquoise1")
        self.radio_ecrit2 = tk.Radiobutton(self.fen, text= "\u25a2", variable = self.ecrit,
                    value=2, command = lambda : self.choixEcrit(2, machine), bg= "paleturquoise1")
        self.label_dep = tk.Label(self.fen, text = "Déplacement", bg= "paleturquoise2",
                              font=("Arial", self.taille_police))
        self.dep = tk.IntVar()
        self.dep.set(1)
        self.radio_depg = tk.Radiobutton(self.fen, text= "Gauche", variable = self.dep,
                           value= -1, command = lambda : self.choixDep(-1, machine), bg= "paleturquoise2")
        self.radio_depd = tk.Radiobutton(self.fen, text= "Droit", variable = self.dep,
                    value=1, command = lambda : self.choixDep(1, machine), bg= "paleturquoise2")
        self.radio_depn = tk.Radiobutton(self.fen, text= "Aucun", variable = self.dep,
                                         bg= "paleturquoise2",
                    state = "disabled", value=0, command = lambda : self.choixDep(0, machine))
        self.frame = tk.Frame(self.fen, padx = 2, pady = 2)
        self.label_transition_c = tk.Label(self.frame, text = "", 
                              font=("Arial", self.taille_police - 2),
                              borderwidth=1, relief="solid")      
        
        
        self.bouton_quitter = tk.Button(self.fen, text="Enregistrer et quitter", 
                                        font=("Arial", self.taille_police),
                                        command = lambda : self.quitter(machine))

        
    def initGUI(self, machine):
        #  résumé
        self.bouton_resume.grid(row=0, column = 0, columnspan = 10, padx = 2, pady = 2)
        self.entree_resume.grid(row = 0, column = 10, columnspan = 10, padx = 2, pady = 2, 
                                sticky = "w")
        #  états
        for i in range(20):
            self.fen.columnconfigure(i, weight=1)
        self.label_init.grid(row = 1, column =12, columnspan = 4, padx = 2, pady = 2)
        self.label_finaux.grid(row = 1, column =16, columnspan = 4, padx = 2, pady = 2)
        self.label_intermediaires.grid(row = 5, column =12, columnspan = 8, padx = 2, pady = 2)
        self.acne[0].grid(row= 2, column = 12, columnspan = 4, padx = 2, pady = 2)
        self.acne[-3].grid(row= 2, column = 16, columnspan = 4, padx = 2, pady = 2)
        self.acne[-2].grid(row= 3, column = 16, columnspan = 4, padx = 2, pady = 2)
        self.acne[-1].grid(row= 4, column = 16, columnspan = 4, padx = 2, pady = 2)
        for i in range(1, (len(self.acne) -4)// 2 + 1):
            self.acne[i].grid(row= i + 6, column = 12, columnspan = 2, padx = 2, pady = 2)
            self.noms_etats_entree[i].grid(row= i + 6, column = 14, columnspan = 2, padx = 2, pady = 2)
        for i in range((len(self.acne) -4) // 2 + 1, len(self.acne) - 3):
            self.acne[i].grid(row= i + 6 - (len(self.acne) -4) // 2, column = 16, columnspan = 2
                              , padx = 2, pady = 2)
            self.noms_etats_entree[i].grid(row= i + 6 - (len(self.acne) -4) // 2, 
                                          column = 18, columnspan = 2, padx = 2, pady = 2)
        
                
        #  transitions
        self.bouton_saisie_transition.grid(row=1, column = 0, columnspan = 10, padx = 2, pady = 2)
        self.label_etat_c.grid(row=2, column = 0, columnspan = 2, padx = 2, pady = 2)
        milieu = len(self.radio_transitions_etats_c)//2
        for i  in range(milieu):
            self.radio_transitions_etats_c[i].grid(row=  3 + i, column = 0, padx = 2, pady = 2)
        for i  in range(milieu, len(self.radio_transitions_etats_c)):
            self.radio_transitions_etats_c[i].grid(row=  3 + i - milieu, column = 1, padx = 2, pady = 2)
        self.label_etat_s.grid(row=2, column = 4, columnspan = 2, padx = 2, pady = 2)
        self.radio_transitions_etats_c[-3].configure(state = "disabled")
        self.radio_transitions_etats_c[-2].configure(state = "disabled")
        self.radio_transitions_etats_c[-1].configure(state = "disabled")
        
        milieu = len(self.radio_transitions_etats_c)//2
        for i  in range(milieu):
            self.radio_transitions_etats_s[i].grid(row=  3 + i, column = 4, padx = 2, pady = 2)
        for i  in range(milieu, len(self.radio_transitions_etats_c)):
            self.radio_transitions_etats_s[i].grid(row=  3 + i - milieu, column = 5, padx = 2, pady = 2)
        
        self.label_lu.grid(row=2, column = 3, padx = 2, pady = 2)
        self.radio_lu0.grid(row=3, column = 3, padx = 2, pady = 2)
        self.radio_lu1.grid(row=4, column = 3, padx = 2, pady = 2)
        self.radio_lu2.grid(row=5, column = 3, padx = 2, pady = 2)
        
        self.label_ecrit.grid(row=2, column = 7, padx = 2, pady = 2)
        self.radio_ecrit0.grid(row=3, column = 7, padx = 2, pady = 2)
        self.radio_ecrit1.grid(row=4, column = 7, padx = 2, pady = 2)
        self.radio_ecrit2.grid(row=5, column = 7, padx = 2, pady = 2)
        
        self.label_dep.grid(row=2, column = 8, padx = 2, pady = 2)
        self.radio_depg.grid(row=3, column = 8, padx = 2, pady = 2)
        self.radio_depd.grid(row=4, column = 8, padx = 2, pady = 2)
        self.radio_depn.grid(row=5, column = 8, padx = 2, pady = 2)
        
        #self.label_transition_c.grid(row = 3 + milieu, column = 0, columnspan = 10)
        
        self.frame.grid(row = 3 + milieu, column = 0, columnspan = 10, rowspan = 6)
        
        #  ruban
        self.bouton_ruban_alea.grid(row= self.num_ligne_ruban,
                                      column = 0, padx = 2, pady = 2, columnspan = 4)
        self.bouton_ruban_entree.grid(row= self.num_ligne_ruban,
                                      column = 4, padx = 2, pady = 2, columnspan = 4)
        self.label_ruban_explications.grid(row= self.num_ligne_ruban + 1,
                                      column = 0, padx = 2, pady = 2, columnspan = 15, sticky ="w")
        self.entree_ruban.grid(row= self.num_ligne_ruban + 2,
                                      column = 0, padx = 2, pady = 2, columnspan = 10, sticky ="w")
        
        
        self.bouton_quitter.grid(row= self.num_ligne_ruban + 2, column = 17, 
                                 columnspan = 3, padx = 2, pady = 2)
        if self.modif :
            self.chargerMachine(machine)
        self.fen.mainloop()

    def chargerMachine(self, machine):
        self.ruban = machine.deroulement[0][0]
        machine.ruban = self.ruban
        self.ruban2ChaineRuban()
        #print(machine)
        self.entree_ruban_text.set(self.chaine_ruban)
        for i in range(1, len(self.etats_construits) - 3):
            if self.etats_construits[i]:
                self.noms_etats[i].set(self.liste_etats[i])
                #self.noms_etats_entree[i].configure(text = self.noms_etats[i])
                self.acne[i].configure(text = self.liste_etats[i], state = "normal")
        if self.etats_construits[self.CODE_FIN]:
            self.choix_fin_fin(machine)
        else :
            self.choix_fin_vrai(machine)
        self.transitions = machine.transitions
        self.frameTransitions()
    
    def frameTransitions(self):
        self.frame.destroy()
        largeur_ecran = self.fen.winfo_screenwidth()
        hauteur_ecran = self.fen.winfo_screenheight()
        self.frame = tk.Frame(self.fen,width = largeur_ecran//2.5, height = hauteur_ecran//9)
        milieu = len(self.radio_transitions_etats_c)//2
        self.frame.grid(row = 3 + milieu, column = 0, columnspan = 10, rowspan = 2)
        self.scroll_bar = tk.Scrollbar(self.frame)
        self.scroll_bar.pack( side = "right", fill = "y" )
        liste_trans = tk.Listbox(self.frame, width = 70,
                 yscrollcommand = self.scroll_bar.set)
        
        for cle_transition in self.transitions.keys() :
            lu = cle_transition[0]
            c = cle_transition[1]
            ecrit = self.transitions[cle_transition][0]
            s = self.transitions[cle_transition][1]
            dep = self.transitions[cle_transition][2]
            if dep == 1:
                chaine_dep = "\u2192"
            elif dep == -1:
                chaine_dep = "\u2190"
            else :
                chaine_dep = "aucun"  
            chaine = "lu : " + self.texte_symboles[lu] + ", courant : " + self.etats[c] +\
            "\n\t\u2192 ecrit : " + self.texte_symboles[ecrit] + ", suivant : " + self.etats[s] +\
                ", déplacement : " + chaine_dep +"\n"
            #print(chaine)
            liste_trans.insert("end", chaine)
        liste_trans.pack( side = "left", fill = "both" )          
        self.scroll_bar.config(command = liste_trans.yview )
    
    def modifResume(self, machine):
        self.resume = self.entree_resume_text.get()
        if len(self.resume) > 70:
            self.resume = self.resume[:70]
        self.bouton_resume.configure(text = self.resume)
        machine.resume = self.resume
    
    def rubanAlea(self, machine):
        self.ruban = [randint(0,4)//2 for i in range(self.lg_ruban)]
        self.ruban[0] = 2
        self.ruban2ChaineRuban()
        self.entree_ruban_text.set(self.chaine_ruban)
        machine.ruban = self.ruban
    
    def rubanEntree(self, machine):
        ruban_temp = self.entree_ruban.get()
        if len(ruban_temp) > self.lg_ruban:
            ruban_temp = ruban_temp[:self.lg_ruban]
        ruban_temp = "2"+ruban_temp[1:]
        for i in range(len(ruban_temp)):
            self.ruban[i] = int(ruban_temp[i])
        for j in range(i, self.lg_ruban):
            self.ruban[j] = 2
        self.ruban2ChaineRuban()
        self.entree_ruban_text.set(self.chaine_ruban)
        machine.ruban = self.ruban
        
    def ruban2ChaineRuban(self):
        self.chaine_ruban = ""
        for code in self.ruban :
            self.chaine_ruban = self.chaine_ruban + self.texte_symboles[code]

    def choixValeurRuban(self, i):
        self.ruban[i] = int(self.var.get())
        self.chaine_ruban[i].configure(text = self.texte_symboles[self.ruban[i]])
    
    def choix_fin_fin(self, machine):
        self.acne[-3].configure(state = "disabled", relief = "raised", bd = 3)
        self.acne[-2].configure(state = "normal", relief = "sunken", bd = 1)
        self.acne[-1].configure(relief = "sunken", bd = 1)
        if self.etats_construits[-5] :
            self.acne[-4].configure(state = "normal", text = "Etat 8")
        else:
            self.acne[-4].configure(state = "disabled", text = "Etat 8")
        self.noms_etats[-1].set("Max 10 car")
        self.label_finaux.configure(text = "Etat final : FIN")
        self.etats_construits[self.CODE_FIN] = True
        self.etats_construits[self.CODE_VRAI] = False
        self.etats_construits[self.CODE_FAUX] = False
        self.nb_etats = self.nb_etats + 1
        self.make_dico_etats(machine)
        self.radio_transitions_etats_c[-4].configure(state = "disabled", text = "Etat 8")
        self.radio_transitions_etats_s[-3].configure(state = "normal")
        self.radio_transitions_etats_s[-2].configure(state = "disabled")
        self.radio_transitions_etats_s[-1].configure(state = "disabled")
        self.radio_transitions_etats_s[-4].configure(state = "disabled", text = "Etat 8")
        for cle in self.transitions.keys():
            if self.transitions[cle][1] == self.CODE_VRAI or self.transitions[cle][1] == self.CODE_FAUX :
                self.transitions.pop(cle)
        
    def choix_fin_vrai(self, machine):
        self.acne[-1].configure(relief = "raised", bd = 3)
        self.acne[-2].configure(state = "disabled", relief = "raised", bd = 3)
        self.acne[-3].configure(state = "normal", relief = "sunken", bd = 1)
        self.acne[-4].configure(state = "disabled", text = "Etat 8 ")
        self.noms_etats[-1].set("Indisponible")
        self.label_finaux.configure(text = "Etats finaux : VRAI/FAUX")
        self.etats_construits[self.CODE_FIN] = False
        self.etats_construits[self.CODE_VRAI] = True
        self.etats_construits[self.CODE_FAUX] = True
        self.etats_construits[-4] = False
        self.nb_etats = self.nb_etats - 1
        self.make_dico_etats(machine)
        self.radio_transitions_etats_c[-4].configure(state = "disabled", text = "Indisponible")
        self.radio_transitions_etats_s[-3].configure(state = "disabled")
        self.radio_transitions_etats_s[-2].configure(state = "normal")
        self.radio_transitions_etats_s[-1].configure(state = "normal")
        self.radio_transitions_etats_s[-4].configure(state = "disabled", text = "Indisponible")
        for cle in self.transitions.keys():
            if self.transitions[cle][1] == self.CODE_FIN :
                self.transitions.pop(cle)
        
    def saisie_etat(self, idx, etape_saisie, machine):
        texte_etat = self.noms_etats[idx].get()
        if len(texte_etat) > 10:
            texte_etat = texte_etat[:10]
        #   Petite rustine pour que le dictionnaire des états soit ordonné
        #   pas sûr que ce soit utile ceci dit... :
        self.acne[idx].configure(text = texte_etat)
        if idx != self.nb_etats -2 : 
            self.acne[idx + 1].configure(state = "normal")
        self.acne[idx].configure(text = texte_etat)
        self.liste_etats[idx] = texte_etat
        self.etats_construits[idx] = True
        self.make_dico_etats(machine)
        self.radio_transitions_etats_c[idx].configure(text = texte_etat, state = "normal")
        self.radio_transitions_etats_s[idx].configure(text = texte_etat, state = "normal")
        
    def make_dico_etats(self, machine):
        self.etats = {self.CODE_INIT: self.ETAT_INIT} 
        for i in range(1, len(self.etats_construits)):
            if self.etats_construits[i] :
                self.etats[i] = self.liste_etats[i]
        machine.etats = self.etats
        #  print(self.etats)
     
    #  Choix par les boutons des éléments d'une transition puis construction de la transition
    def choixLu(self, choix, machine):
        self.def_lu = choix       
    def choixEtatC(self, choix, machine):
        self.def_c = choix   
    def choixEcrit(self, choix, machine):
        self.def_ecrit = choix
    def choixEtatS(self, choix, machine):
        self.def_s = choix
        if choix >= self.CODE_FIN :
            self.radio_depg.configure(state = "disabled", bg= "paleturquoise2")
            self.radio_depd.configure(state = "disabled", bg= "paleturquoise2")
            self.def_dep = 0
            self.dep.set(0)
            self.radio_depn.configure(state = "normal", bg= "paleturquoise2")         
        else :
            self.def_dep = 1
            self.dep.set(1)
            self.radio_depg.configure(state = "normal", bg= "paleturquoise2")
            self.radio_depd.configure(state = "normal", bg= "paleturquoise2")
            self.radio_depn.configure(state = "disabled", bg= "paleturquoise2")
    def choixDep(self, choix, machine):
        self.def_dep = choix
        
    def saisieTransition(self, machine):
        if self.def_dep == 1:
            chaine_dep = "droite"
        elif self.def_dep == -1:
            chaine_dep = "gauche"
        else :
            chaine_dep = "aucun"
        self.transitions[(self.def_lu, self.def_c)] = (self.def_ecrit, self.def_s, self.def_dep)
        machine.transitions[(self.def_lu, self.def_c)] = (self.def_ecrit, self.def_s, self.def_dep)
        #self.listeTransitions()
        self.frameTransitions()
        chaine = "lu : " + self.texte_symboles[self.def_lu] + ", etat courant : " +\
            self.etats[self.def_c] + "\n\t\u2192 ecrit : " +\
            self.texte_symboles[self.def_ecrit] + ", etat suivant : " + self.etats[self.def_s] +\
                ", déplacement : " + chaine_dep
        
    def listeTransitions(self):
        """
        self.frame.destroy()
        self.frame = tk.Frame(self.fen)
        milieu = len(self.radio_transitions_etats_c)//2
        self.frame.grid(row = 3 + milieu, column = 0, columnspan = 10, rowspan = 2)
        self.labels_transitions = []
        """
        for cle_transition in self.transitions.keys() :
            lu = cle_transition[0]
            c = cle_transition[1]
            ecrit = self.transitions[cle_transition][0]
            s = self.transitions[cle_transition][1]
            dep = self.transitions[cle_transition][2]
            if dep == 1:
                chaine_dep = "droite"
            elif dep == -1:
                chaine_dep = "gauche"
            else :
                chaine_dep = "aucun"
            chaine = "lu : " + self.texte_symboles[lu] + ", etat courant : " + self.etats[c] +\
            "\n\t\u2192 ecrit : " + self.texte_symboles[ecrit] + ", etat suivant : " + self.etats[s] +\
                ", déplacement : " + chaine_dep +"\n"
            #print(chaine)
        
    def quitter(self, machine):
        #  print("dans quitter")
        #  print(machine)
        ok = machine.turing()
        if not ok:
            print( "Vous foirâtes votre machine")
        else:
            pass
            #for ligne in machine.deroulement :
            #    print("déroulement :", ligne)
        self.fen_mere.reInitGui()
        self.fen.destroy() 
        